package org.fuseri.modulelanguageschool;

import lombok.RequiredArgsConstructor;
import org.fuseri.modulelanguageschool.user.Address;
import org.fuseri.modulelanguageschool.user.User;
import org.fuseri.modulelanguageschool.user.UserService;
import org.fuseri.modulelanguageschool.user.UserType;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Component;

@RequiredArgsConstructor
@Component
public class DataInitializer implements ApplicationRunner {

    private final UserService userService;

    @Override
    public void run(ApplicationArguments args) {
        User user = User.builder()
                .email("test@email.com")
                .firstName("John")
                .lastName("Doe")
                .username("johnD")
                .password("password")
                .userType(UserType.ADMIN)
                .address(Address.builder()
                        .city("Brno")
                        .country("CZ")
                        .street("Hrnčírska")
                        .houseNumber("99")
                        .build())
                .build();

        userService.create(user);
    }
}
